/* sclovarImport.cpp */

#include "stdio.h"
#include "ctype.h"
#include "io.h"
#include "slovar.h"
#define USE_COMPRESSION 0

#if USE_COMPRESSION
  #include "zlib.h"
#endif


/*+---------------------------------+*/
/*| Internal function prototypes.   |*/
/*+---------------------------------+*/

/* 㭪 ࠢ class VocabIndex  ஢ */
int _Optlink VocabSortCmp(const void* s1, const void* s2);

/* p p  宦 */
/* p頥  p 離  pﭨ  p */
int vb_Strcmp(char* s0, char* s1);

/* ⪠ p ⥪ ᫮p  */
/* 頥  稢訩 ப            */
int  NiceArticle(char *sIn, char *sOut, int len, int lenmax);

/*  ப ( ᨬ  '\n')  ⮣ (筮) 䠩 
 *  sBuf  nBuflen   㫥  p
 * ( p   ᮢ ᫮p  slovo )
 * 頥  ப
 */
int GetStrFromBinFile(char *sBuf, int nBuflen, FILE *fp );




//஢ ᫮ 
// ⥪⮢ ଠ Nike Korolev'
int Vocab::Import(char *fImport, char *_fname, char *VocName, char *VocComment)
{
    FILE *fp;
    int rc,rc0=0;
    int lenWords;
    int nwords;
    int i,l,indWord;
    int lastpos,pos;
    char str[1024];
    char wrd[1024];

    fp = fopen(fImport,"r, blksize=32000");
    if(fp == NULL)
    {   rc0 = 1;
        return rc0;
    }
    if(VocName)
       strncpy(name, VocName,VD_MAXPATH-1);
    if(VocComment)
       strncpy(comment, VocComment,VD_MAXPATH-1);

// ⠥ ᫮ ᫮ ᫮
     nwords = 0;
     lenWords = 0;
     while(!feof(fp))
     {    char *b, *e;
          fgets(str,1024,fp);
          b = strstr(str,"<<<");
          if(!b)
              continue;
          e = strstr(b,">>>");
          if(!e)
              continue;
          for(i = 0, b += 3; b < e; b++, i++)
                           wrd[i] = *b;
          wrd[i] = 0;
          nwords++;
          lenWords += i;

          if(!(nwords%500))
            {  printf("\rw=%i %i",nwords, lenWords); fflush(stdout); }
     }

     printf("\rw=%i %i\n",nwords, lenWords);
     fseek(fp,0L,SEEK_SET);
     n = nwords;
     lenWords = lenWords + n * 2;
     lenWorddata = lenWords+1;
     Worddata = (char *) calloc(lenWorddata,1);    // pp뢭    p饭 n ᫮
     index = new VocabIndex[n];

// 뢠 ᫮ ᫮
     nwords = 0;
     indWord = 0;
     pos = 0;
     while(!feof(fp))
     {    char *b, *e;
          lastpos = pos;
          fgets(str,1024,fp);
          pos = ftell(fp);

          b = strstr(str,"<<<");
          if(!b)
              continue;
          e = strstr(b,">>>");
          if(!e)
              continue;
           b += 3;
// 모 砫 ஡
          for(i=0;i<32;i++)
          {  if(*b > 32)
                       break;
             b++;
          }

          for(i = 0; b < e; b++, i++)
                           wrd[i] = *b;
          wrd[i] = 0;

          l = i;
          index[nwords].word = & Worddata[indWord];
          index[nwords].pos = pos;
          index[nwords].attr = 0;
          if(nwords)
          {  i = lastpos - index[nwords-1].pos;
             index[nwords-1].l = (short int) i;
          }

          for(i = 0; i < l && indWord < lenWords; i++)
          { Worddata[indWord++] = wrd[i];
          }
          Worddata[indWord++] = 0;

          nwords++;
          if(!(nwords%500))
            {  printf("\rw=%i",nwords);  fflush(stdout); }
     }
     if(nwords)
     {  i = lastpos - index[nwords-1].pos;
        index[nwords-1].l = (short int) i;
     }

    printf("\rw=%i %i\n",nwords,indWord);
    fclose(fp);
//    WriteImport(fImport,"aTst0");

//    fprintfIndex("aDoSort.out");
    SortIndex();
//    fprintfIndex("aPosleSort.out");

    CreationTime = time(NULL);   // ६ ᮧ
    LastchangeTime = CreationTime;
    printf("Creation Time time is %s\n", ctime(&CreationTime));

//  ᫮  pp㥬 ⥪⮢ p⠢
    rc = WriteImport(fImport, _fname);
    if(rc)
        rc0 = 4; // 訡  䠩
    strcpy(fname,_fname);

    return rc0;
}

/*  ᫮  pp㥬 ⥪⮢ p⠢ */
/*  ⪮ p ⥪ ᫮p ⥩        */
int Vocab::WriteImport(char *fnameFrom, char *_fnameto)
{  int i,j,l,pos, nExpressons,rc;
   FILE *fpfrom, *fpto;
   char  filename[VD_MAXPATH];
   char * bufin, * bufout;

#if USE_COMPRESSION
     int usecompression = 1;
#endif

//᭠砫 襬 ஢ ᫮ 
   fpfrom = fopen(fnameFrom,"rb, blksize=32000");
   if(fpfrom == NULL)
        return 1;

   strcpy(filename,_fnameto);
   strcat(filename,".dat");
   fpto = fopen(filename,"wb, blksize=32000");
   if(fpto == NULL)
   {    fclose(fpfrom);
        return 2;
   }
   WriteVocHeader(fpto ,2,0,name,comment);

//   if(usecompression)
//       gzFilehandle  = gzdopen(fileno(fpto),"wb");

   bufin = (char *) calloc(0x11000,1);
   bufout = (char *) calloc(0x11000,1);
   printf("Write %s\n",filename);
   pos = ftell(fpto);
   nExpressons = 0;
   for(i = 0; i < n; i++)
   { if(!index[i].l)
               continue;
     fseek(fpfrom,index[i].pos,SEEK_SET);
     fread(bufin,(int)index[i].l,1,fpfrom);
     l =  NiceArticle(bufin, bufout,(int)index[i].l,0xffff);
     index[i].l = l;
     index[i].pos = pos;
//printf("%s pos=%x, l=%i\n%s\n",index[i].word,index[i].pos,(int) index[i].l,bufout);
     for(j=0; j < l; j++)
           if(bufout[j] == '~')  nExpressons++;
#if USE_COMPRESSION
     if(usecompression && l > 128)
     { int lcomp, rcz;
       uLongf destLen=0x10800;

       strncpy(bufin,bufout,l+1);
       rcz = compress((Bytef *)bufout, &destLen,(Bytef *) bufin, l+1);
       if( rcz !=  Z_OK)
       {
          free(bufout); free(bufin);
          fclose(fpfrom); fclose(fpto);
          return 10; // 訡 ᦠ
       }
       if(destLen +2  < l)
       {
//        printf("%.2f\n",100.*destLen/(l+1));
           pos += destLen;
           fwrite(bufout,destLen,1,fpto);
       } else {
           pos += l+1;
           fwrite(bufin,l+1,1,fpto);
       }
     } else {
        pos += l+1;
        fwrite(bufout,l+1,1,fpto);
     }
#else
        pos += l+1;
        fwrite(bufout,l+1,1,fpto);
#endif
       //USE_COMPRESSION
     if(!(i%500))
            {  printf("\rw=%i",i);  fflush(stdout); }
   }
   free(bufout);
   free(bufin);
   fclose(fpfrom);
   fclose(fpto);
   printf("\nWords %i,Expressons %i\n",n, nExpressons);
   {  char str[128];
      sprintf(str,"\nWords %i,Expressons %i\n",n, nExpressons);
      strcat(comment, str);
   }
/* ⥯p 襬  */
   strcpy(filename,_fnameto);
   strcat(filename,".bdx");
   rc = WriteIndex(filename);
   if(rc)
   {    return 2;
   }

/* ⥯p 襬 ᯨ᮪ ᫮ */
   strcpy(filename,_fnameto);
   strcat(filename,".wrd");

   rc = WriteWords(filename);
   if(rc)
   {    return 2;
   }

//   fpto = fopen(filename,"wb");
//   if(fpto == NULL)
//   {    return 2;
//   }
//   printf("Write %s\n",filename);
//
//   WriteVocHeader(fpto ,1,0,name,comment);
//   for(i = 0; i < n; i++)
//   {
//      fwrite((void *)index[i].word, strlen(index[i].word)+1,1,fpto);
//   }
//
//   fclose(fpto);
   return 0;
}



int Vocab::SortIndex(void)
{   int rc;
    char *ploc;
     printf("begin sorting\n");
     ploc = SlovarSetLocale(Locale);
     if(!ploc)
     {  printf("\nError: can't set locale %s",Locale);
        return 1;
     }
     qsort( (void *) index, n, sizeof(class VocabIndex ),VocabSortCmp);
     printf("sorting end\n");
     return 0;
}

int Vocab::fprintfIndex(char *filename)
{  FILE *fp;
   int i;
   fp = fopen(filename,"a");
   fprintf(fp,"********************\n");
   for(i=0;i<n;i++)
   {   fprintf(fp,"%i %i %i %s\n",i,index[i].l, index[i].pos,index[i].word);
   }
   fclose(fp);
   return 0;
}

// ⥪⮢ ଠ <word><separator><article><endofstring>
int Vocab::Import1(char *fImport, char *_fname, char *VocName, char *VocComment, char * separator)
{
    FILE *fp;
    int rc,rc0=0;
    int lastpos,pos,posEq,isEq,l, nstr;
    int nwords;  // ᫮  ᫮
    int isseparator=0;
    int nn,i,lenWords, maxstrlen;
    int indWord;
    char str[1024];
    char wrd[1024];
    char *pBuffer, *pstr;

    if(separator && strlen(separator))
                              isseparator = 1;
    fp = fopen(fImport,"rb, blksize=32000");
    if(fp == NULL)
    {   rc0 = 1;
        return rc0;
    }
    if(VocName)
       strncpy(name, VocName,VD_MAXPATH-1);
    if(VocComment)
       strncpy(comment, VocComment,VD_MAXPATH-1);

// ⠥ ᫮ ᫮ ᫮
    pBuffer = (char *) calloc(256,256);
    nwords = 0;
    lastpos = 0;
    pos = 0;
    isEq = 0;
    nstr = 0;
    posEq = 0;
    lenWords = 0;
    maxstrlen = 256*256-1;
     while(!feof(fp))
     {
        l = GetStrFromBinFile(pBuffer,maxstrlen ,fp );
        nstr++;
        if(isseparator)
        { pstr = strstr(pBuffer,separator);
          if(pstr)
          {  nwords++;
             l = (int)(pstr - pBuffer);
             lenWords  += l;
          }
        } else {
            nwords++;
            lenWords  += l;
        }

        if(!(nwords%200))
              printf("\rw=%i %i",nwords, lenWords);
     }
     printf("\rw=%i \n",nwords);

     n = nwords;
     lenWords = lenWords + n * 2;
     lenWorddata = lenWords+1;
     Worddata = (char *) calloc(lenWorddata,1);    // pp뢭    p饭 n ᫮
     index = new VocabIndex[nwords];

// 뢠 ᫮ ᫮
     nwords = 0;
     indWord = 0;

     fseek(fp,0L,SEEK_SET);

     while(!feof(fp))
     {    char *b, *e;
          int l0;

          lastpos = ftell(fp);
//          fgets(pBuffer,maxstrlen,fp);
          l0 = GetStrFromBinFile(pBuffer,maxstrlen,fp);

          b = pBuffer;
// 모 砫 ஡
          for(i = 0; i < l0; i++)
          {  if(*b > 32)
                       break;
             b++;
          }
          if(isseparator)
          {   e = strstr(b,separator);
              if(!e)
                  continue;

              for(i = 0; b < e; b++, i++)
                           wrd[i] = *b;
              while(wrd[i-1] <= 32 && i) i--;
              wrd[i] = 0;
              l = i;
              l0 = (int)e - (int)pBuffer + 1;
              index[nwords].pos = lastpos + l0;
              index[nwords].word = & Worddata[indWord];
              index[nwords].attr = 0;
             if(nwords)
             {  i = lastpos - index[nwords-1].pos;
                index[nwords-1].l = i;
             }
         } else {
              strcpy(wrd,b);
              l = strlen(wrd);
              l0 = 0;
              index[nwords].pos = 0;
              index[nwords].word = & Worddata[indWord];
              index[nwords].attr = 0;
              index[nwords].l = 0;
          }

          for(i = 0; i < l && indWord < lenWords; i++)
          { Worddata[indWord++] = wrd[i];
          }
          Worddata[indWord++] = 0;

          nwords++;
          if(!(nwords%100))
            {  printf("\rw=%i",nwords); fflush(stdout); }
          if(nwords > n)
          {   printf("\n।०:  ࠧ  㥬 䠩,  ᫮ ४饭\n");
              break;
          }
     }
      //endof while(!feof(fp))

     if(nwords && isseparator)
     {  i = lastpos - index[nwords-1].pos;
        index[nwords-1].l = i;
     }
     printf("\rw=%i \n",nwords);

    fclose(fp);

//    fprintfIndex("aDoSort1.out");
    SortIndex();
//    fprintfIndex("aPosleSort1.out");

    CreationTime = time(NULL);   // ६ ᮧ
    LastchangeTime = CreationTime;
    printf("Creation Time time is %s\n", ctime(&CreationTime));

  //  ᫮  pp㥬 ⥪⮢ p⠢
    rc = WriteImport(fImport,_fname);
    if(rc)
        rc0 = 4; // 訡  䠩

    strcpy(fname,_fname);

    return rc0;


}

// ⥪⮢ ଠ Slowo
int Vocab::Import0(char *fImport, char *_fname, char *VocName, char *VocComment)
{
    FILE *fp;
    int rc,rc0=0;
    int lastpos,pos,posEq,isEq,l, nstr;
    int nwords;  // ᫮  ᫮
    int nn,i,lenWords, maxstrlen;
    int indWord;
    char str[1024];
    char wrd[1024];
    char *pBuffer;

    fp = fopen(fImport,"rb, blksize=32000");
    if(fp == NULL)
    {   rc0 = 1;
        return rc0;
    }

    if(VocName)
       strncpy(name, VocName,VD_MAXPATH-1);
    if(VocComment)
       strncpy(comment, VocComment,VD_MAXPATH-1);

// ⠥ ᫮ ᫮ ᫮
    nwords = 0;
    lastpos = 0;
    pos = 0;
    isEq = 0;
    nstr = 0;
    posEq = 0;
    lenWords = 0;
    maxstrlen = 0;
     while(!feof(fp))
     {
          nn = fread(str,1,1024,fp);
          for(i=0;i<nn;i++,pos++)
          {  if(str[i] == '\n')
             {  nstr++;
                if(pos - lastpos > 2 && isEq)
                {    nwords++;
                     lenWords += posEq - lastpos;
                     if(maxstrlen < pos - lastpos) maxstrlen = pos-lastpos;
                     lastpos = pos;
                     isEq = 0;
                }
             } else if(str[i] == '=') {
                 isEq = 1;
                 posEq = pos;
             }
          }
          if(!(nwords%200))
              printf("\rw=%i %i",nwords, lenWords);
     }
     printf("\rw=%i \n",nwords);
    fclose(fp);

     n = nwords;
     lenWords = lenWords + n * 2;
     lenWorddata = lenWords+1;
     Worddata = (char *) calloc(lenWorddata,1);    // pp뢭    p饭 n ᫮
     index = new VocabIndex[nwords];

// 뢠 ᫮ ᫮
     nwords = 0;
     indWord = 0;
    fp = fopen(fImport,"rb, blksize=32000");
    if(fp == NULL)
        return 2;

    maxstrlen += 16;
    pBuffer = (char *) calloc(maxstrlen,1);

     while(!feof(fp))
     {    char *b, *e;
          int l0;

          lastpos = ftell(fp);
//          fgets(pBuffer,maxstrlen,fp);
          l0 = GetStrFromBinFile(pBuffer,maxstrlen,fp);

          b = pBuffer;
// 모 砫 ஡
          for(i = 0; i < l0; i++)
          {  if(*b > 32)
                       break;
             b++;
          }
          e = strstr(b,"=");
          if(!e)
              continue;

//          rc = sscanf(pBuffer,"%s=",wrd);
//          if(rc != 1)
//                    continue;
          for(i = 0; b < e; b++, i++)
                           wrd[i] = *b;
          while(wrd[i-1] <= 32 && i) i--;
          wrd[i] = 0;
          l = i;
          l0 = (int)e - (int)pBuffer + 1;

          index[nwords].word = & Worddata[indWord];
          index[nwords].pos = lastpos + l0;
          index[nwords].attr = 0;
          if(nwords)
          {  i = lastpos - index[nwords-1].pos;
             index[nwords-1].l = i;
          }

          for(i = 0; i < l && indWord < lenWords; i++)
          { Worddata[indWord++] = wrd[i];
          }
          Worddata[indWord++] = 0;

          nwords++;
          if(!(nwords%100))
            {  printf("\rw=%i",nwords); fflush(stdout); }
          if(nwords > n)
          {   printf("\n।०:  ࠧ  㥬 䠩,  ᫮ ४饭\n");
              break;
          }
     }
      //endof while(!feof(fp))

     if(nwords)
     {  i = lastpos - index[nwords-1].pos;
        index[nwords-1].l = i;
     }
     printf("\rw=%i \n",nwords);

    fclose(fp);

//    fprintfIndex("aDoSort1.out");
    SortIndex();
//    fprintfIndex("aPosleSort1.out");

    CreationTime = time(NULL);   // ६ ᮧ
    LastchangeTime = CreationTime;
    printf("Creation Time time is %s\n", ctime(&CreationTime));

  //  ᫮  pp㥬 ⥪⮢ p⠢
    rc = WriteImport(fImport,_fname);
    if(rc)
        rc0 = 4; // 訡  䠩

    strcpy(fname,_fname);

    return rc0;
}


/* 㭪 ࠢ class VocabIndex */
int _Optlink VocabSortCmp(const void* s1, const void* s2)
{
    class VocabIndex * pvInd1, *pvInd2;
    char str1[512],str2[512],ch, *ps1, *ps2;
    int i,j,l1,l2;
    int rc;

    pvInd1 =(VocabIndex *) s1;
    pvInd2 =(VocabIndex *) s2;
    ps1 = pvInd1->word;
    l1 = strlen(ps1);
    ps2 = pvInd2->word;
    l2 = strlen(ps2);
    if(l1 >= 511 || l2 >= 511)
    {   rc = strcoll(pvInd1->word,pvInd2->word);
        if(rc == 0 && pvInd1->pos >= 0 && pvInd2->pos >= 0)
               rc = pvInd1->pos - pvInd2->pos;
        return rc;
    }
/*  뢠 p p  pp '-'  p 樨  '|' */
    for(i=j=0; i < l1; i++)
    {  ch =  *ps1++;
       if(ch == '-' && i == 0) continue;
       if(ch == '|') continue;
       str1[j++] = ch;
    }
    str1[j] = 0;
    for(i=j=0; i < l2; i++)
    {  ch =  *ps2++;
       if(ch == '-' && i == 0) continue;
       if(ch == '|') continue;
       str2[j++] = ch;
    }
    str2[j] = 0;

    rc = strcoll(str1,str2);
    if(rc == 0 && pvInd1->pos >= 0 && pvInd2->pos >= 0)
           rc = pvInd1->pos - pvInd2->pos;

    return rc;
}



/* p p  宦 */
/* p頥  p 離  pﭨ  p */
int vb_Strcmp(char* s0, char* s1)
{   int l0, l1, l, d, d1 ,i, rc;
    int weight;

    rc = 0;
    if(s0 == NULL)
    {   if(s1 == NULL)
            return 0;
        else
            return 32;
    }
    else if(s1 == NULL)
        return 32;

    l0 = strlen(s0);
    l1 = strlen(s1);
    l  = l0;
    if(l0 != l1)
    {   rc += abs(l1 - l0);
        if(l1 < l0)
            l = l1;
    }
    for(i=0;i<l;i++)
    {   d = s0[i]-s1[i];
        if(!d)
            continue;
        d1 = toupper(s0[i]) - toupper(s1[i]);
        if(!d1)
            continue;
        weight = l - i;
        if(weight > 10)
        {  weight = 10 + weight/10;
        }
        rc += abs(d) * weight;
    }
    return rc;
}

/* ⪠ p ⥪ ᫮p  */
/* 頥  稢訩 ப            */
int  NiceArticle(char *sIn, char *sOut, int len, int lenmax)
{
    int i,j,l;
    char *s, ch;
// 㤠塞 ஡  砫 
    s = sIn;
    for(i=0;i<len;i++)
    {  if(sIn[i] > 32)
                 break;
       s++;
    }
    len -= i;
    if(len <= 0) return 0;
    if(len > lenmax)
               len = lenmax;
//    strncpy(sOut,s,len);
/* 㥬    ஡ */
    for(i=j=0;i<len;i++)
    {   ch = s[i];
        if(j && ch <= 32 && sOut[j-1] <= 32)
                                      continue;
        if(j && ch == ';' && sOut[j-1] <= 32)
        {   ch = sOut[j-1];       // 塞 "blabla ;" -> "blabla; " (! - Slovo)
            sOut[j-1] = ';' ;
        }
        if(ch == 0) ch = ' '; // 㡨ࠥ 㫨 (! - Slovo)
        if(ch == '\r')
                   ch = '\n';  //  "\n\r" -> "\n"
        if(j >= 2 && sOut[j-1] == '.' &&  ch == '\n')
        {   if( isdigit((int)sOut[j-2])  && (j==2 || sOut[j-3] == '\n' ) )
                         ch = ' ';  // 㡨ࠥ "1.\nbla-bla-bla"
        }
        sOut[j++] = ch;
    }
    len = j;
    sOut[len] = 0;
// 㤠塞 ஡   
    l = len;
    for(i = l - 1; i > 0; i--)
    {  if(sOut[i] > 32)
       { if(sOut[i] != ';' && sOut[i] != ',' && sOut[i] != '.')
                                                            break;
       }
       sOut[i]=0;
    }
    l = strlen(sOut);
    return l;
}

/*  fgets
    ப ( ᨬ  '\n')  ⮣ (筮) 䠩 
    sBuf  nBuflen   㫥  p
   ( p   ᮢ ᫮p  slovo )
   頥  ப
*/
int GetStrFromBinFile(char *sBuf, int nBuflen, FILE *fp )
{   int i,rc;
    char ch;
    for(i = 0; i < nBuflen - 1; i++)
    {   rc = fread(&ch,1,1,fp);
        if(rc != 1)   break;
        if(ch == '\n') break;
        if(ch == 0) ch = ' ';
       sBuf[i] = ch;
    }
    sBuf[i] = 0;
    return i;
}

